// This will toggle the tab bar.

function toggleBar() {
	if (!gBrowser.mPrefs.getBoolPref("browser.tabs.forceHide")) {
		gBrowser.mPrefs.setBoolPref("browser.tabs.forceHide", true);
		gBrowser.setStripVisibilityTo(false);
		return;
	}
	gBrowser.mPrefs.setBoolPref("browser.tabs.forceHide", false);
	gBrowser.setStripVisibilityTo(true);
}

// This will trigger the toggle when the chosen key is pressed. Based on SwiftTabs by Gom Kim.

function hidetb(event)	{
	pref_keytotoggle = getPrefValue("pref_keytotoggle","int");
	pref_ctrl = getPrefValue("pref_ctrl","bool");
	pref_alt = getPrefValue("pref_alt","bool");	  
	pref_shift =	getPrefValue("pref_shift","bool");
	pref_comm = getPrefValue("pref_comm","bool");	
	pref_override = getPrefValue("pref_override","bool");
	
	if (!pref_keytotoggle)
		pref_keytotoggle = KeyEvent.DOM_VK_F1;

	keyCode =	event.keyCode;
	
	keyApplied = false;
	
	if (!pref_override) {
		if (keyCode < KeyEvent.DOM_VK_F1 || keyCode > KeyEvent.DOM_VK_F12) {
			var elt =	document.commandDispatcher.focusedElement;
			if (elt) {
				var ln = elt.localName.toLowerCase();
				if (ln == "input" || ln == "textarea" ||	ln == "select"	|| ln == "button" || ln == "isindex")
				return;
			}
			
			var win =	document.commandDispatcher.focusedWindow;
			if (win && win.document.designMode	== "on")
				return;
		}
	}
	
	if (pref_keytotoggle > 1000) {
		keyCode = event.charCode + 1000;
	} else {
		keyCode = event.keyCode;
	}

	if (keyCode == pref_keytotoggle && event.metaKey == pref_comm && event.ctrlKey == pref_ctrl && event.altKey == pref_alt && event.shiftKey == pref_shift) {
		toggleBar();						//calling for toggle.
		keyApplied = true;
	}

	if (pref_override && keyApplied) {	
		event.preventDefault();
		event.preventBubble();
		event.preventCapture();
		event.stopPropagation();
	}
}

function initOptionsWindow() {
	obj1	= document.getElementById("togglekey");
	
	document.getElementById("keytotoggle").value =	getPrefValue("pref_keytotoggle","int");
	document.getElementById("ctrl").checked = getPrefValue("pref_ctrl","bool");
	document.getElementById("alt").checked =	getPrefValue("pref_alt","bool");
	document.getElementById("comm").checked = getPrefValue("pref_comm","bool");
	document.getElementById("shift").checked	= getPrefValue("pref_shift","bool");
	document.getElementById("override").checked	= getPrefValue("pref_override","bool");
}

function getPrefValue(prefName,prefType) {
	var prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('hidetb.');
	if (prefService.prefHasUserValue(prefName)) {
		switch (prefType) {
			case	'int': return prefService.getIntPref(prefName);
			case	'bool': return	prefService.getBoolPref(prefName);
		}
	} else {
		return false;
	}
}

function setPrefValue() {
	var prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('hidetb.');
	prefService.setIntPref("pref_keytotoggle",document.getElementById("keytotoggle").value);
	prefService.setBoolPref("pref_ctrl",document.getElementById("ctrl").checked);
	prefService.setBoolPref("pref_alt",document.getElementById("alt").checked);
	prefService.setBoolPref("pref_shift",document.getElementById("shift").checked);
	prefService.setBoolPref("pref_comm",document.getElementById("comm").checked);
	prefService.setBoolPref("pref_override",document.getElementById("override").checked);
}

window.addEventListener("keypress", hidetb, false);